#ifndef AFFICHAGE_HPP
#define AFFICHAGE_HPP


#include <iostream>
#include <vector>
#include <SDL.h>
#include <GL/glew.h>

#include "Model.hpp"

#include "alut.h"

// Fichiers relatifs  Newton
#include "NewtWorld.hpp"
#include "NewtBody.hpp"
#include "NewtCollisionPrimitives.hpp"
#include "NewtCollisionTree.hpp"
#include "NewtMaterialID.hpp"
#include "NewtMaterialPair.hpp"

// Foncteur servant  librer un pointeur - applicable  n'importe quel type
struct Delete 
{ 
   template <class T> void operator ()(T*& p) const 
   { 
      delete p;
      p = NULL;
   } 
}; 

class Affichage
{
	public:
		// Constructeur / Destructeur
		Affichage ();
		~Affichage ();

		// Fonctions d'initialisations
	   void InitSDL ();
		void InitOGL ();

		// Boucle
		void Boucle ();

		// Fonction pour charger les lments de la scne
		void InitScene ();
		
		// Fonction d'update et de rendu
		void Update ();
		void Render ();

		// Affichage du FPS
		void GetFPS ();

		// Dtruit tout
		void Shutdown ();

	private:
		bool _debug; // Mode debug activ ou non ?

		NewtWorld * _nWorld; // Pointeur vers un objet NewtWorld
		std::vector <NewtBody *> _vBody; // Un vecteur reprsentant nos objets Newton
		std::vector <NewtMaterialPair *> _vMaterials; // Un vector stockant les matriaux
};

#endif // AFFICHAGE_HPP
