#include "Matrix.hpp"

Matrix::Matrix ()
{
	for (int i = 0 ; i < 16 ; ++i)
		_matrix [i] = 0.0f;
}

Matrix::Matrix (const Matrix & matrix)
{
	*this = matrix;
}

Matrix::Matrix (const float r11, const float r12, const float r13, const float r14,
                const float r21, const float r22, const float r23, const float r24,
                const float r31, const float r32, const float r33, const float r34,
                const float r41, const float r42, const float r43, const float r44)
{
   // To set the matrix identity you set all the values in the matrix like so...
   _matrix[0]  = r11; _matrix[1]  = r12; _matrix[2]  = r13; _matrix[3]  = r14;
	_matrix[4]  = r21; _matrix[5]  = r22; _matrix[6]  = r23; _matrix[7]  = r24;
	_matrix[8]  = r31; _matrix[9]  = r32; _matrix[10] = r33; _matrix[11] = r34;
	_matrix[12] = r41; _matrix[13] = r42; _matrix[14] = r43; _matrix[15] = r44;
}

Matrix::~Matrix ()
{
}

Matrix & Matrix::operator = (const Matrix & rhs)
{
	for (int i = 0 ; i < 16 ; ++i)
		_matrix [i] = rhs._matrix [i];

	return *this;
}

Matrix Matrix::operator * (const Matrix & rhs)
{
	return Matrix (_matrix[0] * rhs._matrix[0] + _matrix[4] * rhs._matrix[1] + _matrix[8] *
   rhs._matrix[2] + _matrix[12] * rhs._matrix[3],
	_matrix[1] * rhs._matrix[0] + _matrix[5] * rhs._matrix[1] + _matrix[9] *
   rhs._matrix[2] + _matrix[13] * rhs._matrix[3],
	_matrix[2] * rhs._matrix[0] + _matrix[6] * rhs._matrix[1] + _matrix[10] *
   rhs._matrix[2] + _matrix[14] * rhs._matrix[3],
	_matrix[3] * rhs._matrix[0] + _matrix[7] * rhs._matrix[1] + _matrix[11] *
   rhs._matrix[2] + _matrix[15] * rhs._matrix[3],
	_matrix[0] * rhs._matrix[4] + _matrix[4] * rhs._matrix[5] + _matrix[8] *
   rhs._matrix[6] + _matrix[12] * rhs._matrix[7],
	_matrix[1] * rhs._matrix[4] + _matrix[5] * rhs._matrix[5] + _matrix[9] *
   rhs._matrix[6] + _matrix[13] * rhs._matrix[7],
	_matrix[2] * rhs._matrix[4] + _matrix[6] * rhs._matrix[5] + _matrix[10] *
   rhs._matrix[6] + _matrix[14] * rhs._matrix[7],
	_matrix[3] * rhs._matrix[4] + _matrix[7] * rhs._matrix[5] + _matrix[11] *
   rhs._matrix[6] + _matrix[15] * rhs._matrix[7],
	_matrix[0] * rhs._matrix[8] + _matrix[4] * rhs._matrix[9] + _matrix[8] *
   rhs._matrix[10] + _matrix[12] * rhs._matrix[11],
	_matrix[1] * rhs._matrix[8] + _matrix[5] * rhs._matrix[9] + _matrix[9] *
   rhs._matrix[10] + _matrix[13] * rhs._matrix[11],
	_matrix[2] * rhs._matrix[8] + _matrix[6] * rhs._matrix[9] + _matrix[10] *
   rhs._matrix[10] + _matrix[14] * rhs._matrix[11],
	_matrix[3] * rhs._matrix[8] + _matrix[7] * rhs._matrix[9] + _matrix[11] *
   rhs._matrix[10] + _matrix[15] * rhs._matrix[11],
	_matrix[0] * rhs._matrix[12] + _matrix[4] * rhs._matrix[13] + _matrix[8] *
   rhs._matrix[14] + _matrix[12] * rhs._matrix[15],
	_matrix[1] * rhs._matrix[12] + _matrix[5] * rhs._matrix[13] + _matrix[9] *
   rhs._matrix[14] + _matrix[13] * rhs._matrix[15],
	_matrix[2] * rhs._matrix[12] + _matrix[6] * rhs._matrix[13] + _matrix[10] *
   rhs._matrix[14] + _matrix[14] * rhs._matrix[15],
	_matrix[3] * rhs._matrix[12] + _matrix[7] * rhs._matrix[13] + _matrix[11] *
   rhs._matrix[14] + _matrix[15] * rhs._matrix[15]);

	std::cout << rhs._matrix[12];
}

void Matrix::LoadIdentity ()
{
	_matrix [0] = _matrix [5] = _matrix [10] = _matrix [15] = 1.0f;
}

void Matrix::RotationX (const int rotationX)
{
	float sine1 = sinf(rotationX * 3.1416 / 180);
   float cosine1 = cosf(rotationX * 3.1416 / 180);

   // On applique les rotations  la matrice
   _matrix [5] = cosine1;
   _matrix [6] = -sine1;
   _matrix [9] = sine1;
   _matrix [10] = cosine1;
}

void Matrix::RotationY (const int rotationY)
{
	float sine1 = sinf(rotationY * 3.1416 / 180);
   float cosine1 = cosf(rotationY * 3.1416 / 180);

   _matrix [0] = cosine1;
   _matrix [2] = -sine1;
   _matrix [8] = sine1;
   _matrix [10] = cosine1;
}

void Matrix::RotationZ (const int rotationZ)
{
	float sine1 = sinf(rotationZ * 3.1416 / 180);
   float cosine1 = cosf(rotationZ * 3.1416 / 180);

   _matrix [0] = cosine1;
   _matrix [1] = -sine1;
   _matrix [4] = sine1;
   _matrix [5] = cosine1;
}