#ifndef MODEL_H
#define MODEL_H

#include <algorithm>
#include <cmath>
#include "Matrix.hpp"
#include "Mesh.hpp"

class CModel
{
   public:
      CModel ();
      virtual ~CModel ();

      bool OuvrirFichier (std::string nomFichier);
      void Shutdown ();

      void Dessiner ();
		void SetPosition (const float * matrix);
		void SetOffset ();

      int GetNumMeshs () const {return m_iNumMesh;}
      int GetNumFaces (int i) const {return m_vMeshs [i]->GetNumFaces ();}

		CVector GetLongueurs () const;

      CMesh * GetMesh (int i) const {return m_vMeshs [i];}

      std::vector <aseFace> GetFaces (int i) const {return m_vMeshs [i]->GetFaces();}
      std::vector <aseVertex> GetVertices (int i) const {return m_vMeshs [i]->GetVertices();}

   private:
      int m_iNumMesh;
      int m_iNumMaterials;

		Matrix _matrix;
		CVector _offset;

      std::vector <CMesh *> m_vMeshs;
      std::vector <aseMaterial> m_vMaterials;
};

#endif // MODEL_H

