#include "NewtCollision.hpp"

// Constructeur
NewtCollision::NewtCollision ()
	: _nCollision (NULL)
{
	_nWorld = NewtWorld::GetInstance (); // On rcupre le pointeur vers l'objet NewtWorld
}

// Destructeur
NewtCollision::~NewtCollision ()
{
	// Ne fait rien
}

// Libre la mmoire de la primitive de collision. Cette fonction DOIT ABSOLUMENT ETRE
// appel une fois la primitive de collision assigne  un corps, afin de ne pas
// crer de fuites mmoire.
void NewtCollision::NewtReleaseCollision () const
{
	// On appelle la fonction NewtonReleaseCollision
	NewtonReleaseCollision (_nWorld->GetNewtonWorld(), _nCollision);
}

// Fonction renvoyant un volume approximatif du corps
float NewtCollision::NewtConvexCollisionCalculateVolume () const
{
	return (NewtonConvexCollisionCalculateVolume (_nCollision));
}

// Calcule le centre de masse (ou centre d'inertie) de la primitive de collision
void NewtCollision::NewtConvexCollisionCalculateInertialMatrix (CVector & inertie, CVector & origine)
{
	NewtonConvexCollisionCalculateInertialMatrix (_nCollision, &inertie.x, &origine.x);
}

// Cette fonction permet de rendre une primitive de collision unique. En effet, si vous
// crez deux primitives de collision identique, par exemple une primitive de collision
// box avec les dimensions (1,1,1) appele box1 et une seconde box avec les mmes dimensions
// (1,1,1) appele box2, Newton considrera que box1=box2, alors que si vous crez votre
// premire box (box1), que vous appelez cette fonction et que vous crez votre deuxime
// box (box2), alors Newton considrera que box1!=box2.
void NewtCollision::NewtCollisionMakeUnique () const
{
	NewtonCollisionMakeUnique (_nWorld->GetNewtonWorld(), _nCollision);
}