#ifndef MATRIX_HPP
#define MATRIX_HPP

#include <iostream>
#include <vector>
#include <cmath>

class Matrix
{
	public:
		Matrix ();
		Matrix (const Matrix & mat);
		Matrix (const float r11, const float r12, const float r13, const float r14,
              const float r21, const float r22, const float r23, const float r24,
              const float r31, const float r32, const float r33, const float r34,
              const float r41, const float r42, const float r43, const float r44);
		~Matrix ();

		Matrix & operator= (const Matrix & rhs); // Surcharge de l'oprateur =
		Matrix operator * (const Matrix & rhs); // Surcharge de l'oprateur *=

		void Matrix::operator *=(const Matrix & m)
		{
			(*this) = (*this) * m;
		}

		void LoadIdentity (); // Met la matrice identit

		// Fonctions de rotation sur les trois axes
		void RotationX (const int rotationX);
		void RotationY (const int rotationY);
		void RotationZ (const int rotationZ);
	
		// Dclar public, pour plus de simplicit
		float _matrix [16]; // 16 entiers (matrice 4*4)
};

#endif // MATRIX_HPP
