#include "NewtCollisionTree.hpp"

// Constructeur
NewtCollisionTree::NewtCollisionTree (CModel * model, const bool optimize)
	: NewtCollision ()
{
	// On dbute la cration de l'arbre de collision
	_nCollision = NewtonCreateTreeCollision (_nWorld->GetNewtonWorld(), NULL);

	NewtonTreeCollisionBeginBuild (_nCollision);

	int strideInBytes = sizeof (float) * 3;
	float fVert [9];
	
	// Pour chaque mesh du modle 3D...
	for (int i = 0 ; i < model->GetNumMeshs() ; ++i)
	{
		// ... on rcupre les coordonnes de chaque sommet et les faces
		std::vector <aseVertex> vertTmp = model->GetMesh (i)->GetVertices ();
		std::vector <aseFace> faceTmp = model->GetMesh (i)->GetFaces ();
		
		// Puis on parcourt chaque face...
		for (int j = 0 ; j < model->GetMesh (i)->GetNumFaces () ; ++j)
		{
			fVert [0] = vertTmp[faceTmp[j].indexVertices [0]].x;
			fVert [1] = vertTmp[faceTmp[j].indexVertices [0]].y;
			fVert [2] = vertTmp[faceTmp[j].indexVertices [0]].z;
			fVert [3] = vertTmp[faceTmp[j].indexVertices [1]].x;
			fVert [4] = vertTmp[faceTmp[j].indexVertices [1]].y;
			fVert [5] = vertTmp[faceTmp[j].indexVertices [1]].z;
			fVert [6] = vertTmp[faceTmp[j].indexVertices [2]].x;
			fVert [7] = vertTmp[faceTmp[j].indexVertices [2]].y;
			fVert [8] = vertTmp[faceTmp[j].indexVertices [2]].z;
			
			// ... qu'on ajoute grce  NewtonTreeCollisionAddFace
			NewtonTreeCollisionAddFace (_nCollision, 3, &fVert [0], strideInBytes, 0);
		}
	}
	
	// On finalise ensuite l'arbre de collision ou activant ou non les optimisations. Je 
	// n'ai jamais eu de problme en optimisant et les rsultats sont parfois normes, je vous
	// conseille donc de toujours optimiser.
	if (optimize)
		NewtonTreeCollisionEndBuild (_nCollision, 1);
	else
		NewtonTreeCollisionEndBuild (_nCollision, 0);
}

// Destructeur
NewtCollisionTree::~NewtCollisionTree ()
{
}
